<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../bower_components/polymer/polymer.html">
<link rel="import" href="../bower_components/iron-flex-layout/iron-flex-layout.html">
<link rel="import" href="../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="../bower_components/iron-overlay-behavior/iron-overlay-behavior.html">
<link rel="import" href="food-button.html">
<link rel="import" href="food-cart-item.html">

<dom-module id="food-order-success-modal">

  <template>

    <style include="food-button">

      :host {
        display: block;
        position: fixed;
        background-color: #FFF;
        box-shadow: 0 0 10px rgba(0, 0, 0, 0.2);
        min-width: 320px;
        max-width: 480px;
        width: 100%;
        padding: 12px;
        visibility: hidden;
        will-change: transform;
        top: 56px;
        right: 16px;
        -webkit-transform: translate3d(calc(100% + 16px), 0, 0);
        transform: translate3d(calc(100% + 16px), 0, 0);
        transition-property: visibility, -webkit-transform;
        transition-property: visibility, transform;
        transition-duration: 0.2s;
        transition-delay: 0.1s;
      }

      :host(.opened) {
        visibility: visible;
        -webkit-transform: translate3d(0, 0, 0);
        transform: translate3d(0, 0, 0);
      }

      .layout-horizontal {
        @apply --layout-horizontal;
      }

      .label {
        @apply --layout-flex;
        line-height: 24px;
        margin: 8px;
        font-weight: bold;
      }

      .modal-button {
        @apply --layout-flex;
        margin: 16px 8px;
      }

      .modal-button > * {
        box-sizing: border-box;
        width: 100%;
        padding: 8px 24px;
      }

      #closeBtn {
        position: absolute;
        right: 5px;
        top: 5px;
      }

      @media (max-width: 767px) {

        :host {
          top: auto;
          bottom: 0;
          left: 0;
          right: 0;
          width: auto;
          -webkit-transform: translate3d(0, 100%, 0);
          transform: translate3d(0, 100%, 0);
        }

      }

      .checkout-box
      {
        text-align: right;
      }

    </style>

    <div class="label">Заказ [[order.number]] успешно принят</div>
    <div class="list">
        <dom-repeat items="[[order.cart]]" as="entry">
          <template>
            <food-cart-item entry="[[entry]]"></food-cart-item>
          </template>
        </dom-repeat>
      </div>
      <div class="checkout-box">
        <div>Всего: <span class="subtotal">[[order.total]]</span></div>

        <div class="label">Время доставки</div>
        <div><span class="subtotal">[[_deliveryTime(order.delivery)]]</span></div>
        
        <div class="label">Оплата
            <span class="subtotal">[[_selectedPayment(order.pay)]]</span>
        </div>        
      </div>
      
    <div class="layout-horizontal">
      <food-button class="modal-button">
        <a href="/" on-tap="close" id="goHomeAnchor">Домой</a>
      </food-button>
      <food-button class="modal-button">
        <a href="#" on-tap="close" id="closeModalAnchor">Закрыть</a>
      </food-button>
    </div>

    <paper-icon-button icon="close" id="closeBtn" aria-label="Close dialog" on-tap="close"></paper-icon-button>

  </template>

  <script>


    Polymer({

      is: 'food-order-success-modal',

      behaviors: [
        Polymer.IronOverlayBehaviorImpl
      ],

      properties: {
        withBackdrop: {
          type: Boolean,
          value: true
        },
      
        order: {
          type: Object
        }
      },

      hostAttributes: {
        role: 'dialog',
        'aria-modal': 'true'
      },

      listeners: {
        'transitionend' : '_transitionEnd',
        'iron-overlay-canceled': '_onCancel'
      },

      _renderOpened: function() {
        this.restoreFocusOnClose = true;
        this.backdropElement.style.display = 'none';
        this.classList.add('opened');
      },

      _renderClosed: function() {
        this.classList.remove('opened');
      },
      _deliveryTime:function(time)
      {
        return fecha.format(time, 'HH:mm MMMM Do, YYYY');
      },
      _selectedPayment:function(payment)
      {
         return payment == 'delivery' ? "По доставке":"Исполнено"
      },
      _onCancel: function(e) {
        // Don't restore focus when the overlay is closed after a mouse event
        if (e.detail instanceof MouseEvent) {
          this.restoreFocusOnClose = false;
        }
      },

      _transitionEnd: function(e) {
        if (e.target !== this || e.propertyName !== 'transform') {
          return;
        }
        if (this.opened) {
          this._finishRenderOpened();
          this.fire('announce', 'Order successful');
        } else {
          this._finishRenderClosed();
          this.backdropElement.style.display = '';
        }
      },

      get _focusableNodes() {
        return [this.$.goHomeAnchor, this.$.closeBtn];
      },

      refit: Function(),

      notifyResize: Function()

    });

  </script>

</dom-module>
